import java.io.*;
import java.awt.*;
public class XPROAssembler{
    public static void main(String[]args){
        FileInputStream fis=null;
        String file=null;
        if(args.length!=6){
            System.out.println("6 arguments needed: java XPROAssembler file stacklen temptablelength temptabledata vartablelength vartabledata");
            return;
        }
        int stacklen=0;
        int temptablelength=0;
        int temptabledata=0;
        int variablelength=0;
        int variabledata=0;
        int charactersstart=0;
        try{
            file=args[0];
            fis=new FileInputStream(file);
            stacklen=new Integer(args[1]).intValue();
            temptablelength=new Integer(args[2]).intValue();
            temptabledata=new Integer(args[3]).intValue();
            variablelength=new Integer(args[4]).intValue();
            variabledata=new Integer(args[5]).intValue();
        }
        catch(Exception e1){
            System.out.println("argument error: "+e1);
            return;
        }
        ASMList asml=new ASMList();
        assemble(file,asml);
        assemble("xprobios.txt",asml);
        try{
            FileOutputStream fos=new FileOutputStream("dataarea.txt");
            PrintStream ps=new PrintStream(fos);
            ps.println("AVALUE:");
            ps.println("WORD 0");
            ps.println("BVALUE:");
            ps.println("WORD 0");
            ps.println("CVALUE:");
            ps.println("WORD 0");
            ps.println("DVALUE:");
            ps.println("WORD 0");
            ps.println("EVALUE:");
            ps.println("WORD 0");
            ps.println("FVALUE:");
            ps.println("WORD 0");
            ps.println("GVALUE:");
            ps.println("WORD 0");
            ps.println("HVALUE:");
            ps.println("WORD 0");
            ps.println("IVALUE:");
            ps.println("WORD 0");
            ps.println("JVALUE:");
            ps.println("WORD 0");
            ps.println("KVALUE:");
            ps.println("WORD 0");
            ps.println("LVALUE:");
            ps.println("WORD 0");
            ps.println("MVALUE:");
            ps.println("WORD 0");
            ps.println("NVALUE:");
            ps.println("WORD 0");
            ps.println("SAVALUE:");
            ps.println("WORD 0");
            ps.println("SBVALUE:");
            ps.println("WORD 0");
            ps.println("SCVALUE:");
            ps.println("WORD 0");
            ps.println("SDVALUE:");
            ps.println("WORD 0");
            ps.println("SEVALUE:");
            ps.println("WORD 0");
            ps.println("SFVALUE:");
            ps.println("WORD 0");
            ps.println("SGVALUE:");
            ps.println("WORD 0");
            ps.println("SHVALUE:");
            ps.println("WORD 0");
            ps.println("SIVALUE:");
            ps.println("WORD 0");
            ps.println("SJVALUE:");
            ps.println("WORD 0");
            ps.println("SKVALUE:");
            ps.println("WORD 0");
            ps.println("AHVALUE:");
            ps.println("WORD 0");
            ps.println("BHVALUE:");
            ps.println("WORD 0");
            ps.println("CHVALUE:");
            ps.println("WORD 0");
            ps.println("DHVALUE:");
            ps.println("WORD 0");
            ps.println("EHVALUE:");
            ps.println("WORD 0");
            ps.println("FHVALUE:");
            ps.println("WORD 0");
            ps.println("GHVALUE:");
            ps.println("WORD 0");
            ps.println("HHVALUE:");
            ps.println("WORD 0");
            ps.println("SCREENBUFFERINDEX:");
            ps.println("WORD 0");
            ps.println("FORFLAG:");
            ps.println("WORD 1");
            ps.println("STACK:");
            ps.println("SELFNEXT");
            ps.println("DATA "+stacklen);
            ps.println("TEMPTABLESTR:");
            ps.println("DATA "+temptablelength);
            ps.println("TEMPEND:");
            ps.println("SELFNEXT");
            ps.println("DATA "+temptabledata);
            ps.println("VARTABLE:");
            ps.println("DATA "+variablelength);
            ps.println("MALLOCEND:");
            ps.println("SELFNEXT");
            ps.println("DATA "+variabledata);
            ps.println("INPUTAREA:");
            ps.println("DATA "+1000);
            ps.println("CURSORX:");
            ps.println("WORD 0");
            ps.println("CURSORY:");
            ps.println("WORD 0");
            ps.println("CURSORXB:");
            ps.println("WORD 0");
            ps.println("KEYLEFT:");
            ps.println("WORD 8");
            ps.println("RND:");
            ps.println("WORD 12345");
            ps.println("SCREEN:");
            ps.println("WORD 12");
            ps.println("COLOR:");
            ps.println("WORD 16777215");
            ps.println("POINT:");
            ps.println("WORD 1");
            ps.println("WORD 46");
            ps.println("INKEY:");
            ps.println("WORD 0");
            ps.println("WORD 0");
            ps.println("WORD 0");
            ps.println("CLOSENR:");
            ps.println("WORD 0");
            ps.println("FILENR:");
            ps.println("DATA 5");
            ps.println("IFSTRUCT:");
            ps.println("WORD 0");
            ps.println("IFSTACK:");
            ps.println("DATA 10");
            ps.println("IFBASE:");
            ps.println("WORD 0");
            ps.println("IFCALLS:");
            ps.println("DATA 10");
            ps.println("CHARACTERS:");
            fos.close();
        }
        catch(Exception e2){
            System.out.println("DATAAREA error: "+e2);
        }
        assemble("dataarea.txt",asml);
        charactersstart=asml.length;
        try{
            FileOutputStream fos=new FileOutputStream(file+".obj");
            ASM cur=asml.start;
            while(cur!=null){
                if(cur.constant!=null){
                    int posv=asml.lt.getPos(cur.constant);
                    if(cur.constant.equals("CHARACTERS")){
                        posv=charactersstart;
                    }
                    if(posv!=-1){
                        if(posv>=256*256){
                            fos.write(17);
                            fos.write((posv/(256*256*256))%256);
                            fos.write((posv/(256*256))%256);
                            fos.write(9+(cur.regc-1)*2+1);
                            fos.write(17);
                            fos.write((posv/256)%256);
                            fos.write(posv%256);
                            fos.write(9+(cur.regc-1)*2);
                            cur=cur.next;
                        }
                        else{
                            fos.write(cur.opcode);
                            fos.write(posv/256);
                            fos.write(posv%256);
                            fos.write(cur.regc);
                        }
                    }
                    else{
                        System.out.println("LABEL "+cur.constant+" not found in pos "+posv);
                    }
                }
                else{
                    fos.write(cur.opcode);
                    fos.write(cur.rega);
                    fos.write(cur.regb);
                    fos.write(cur.regc);
                }
                cur=cur.next;
            }
            FileInputStream fis2=new FileInputStream("DATA.DAT");
            int inp=0;
            while((inp=fis2.read())!=-1){
                fos.write(inp);
            }
            fos.close();
        }
        catch(Exception e3){
            System.out.println("write error: "+e3);
        }
        System.out.println("compiled");
    }
    public static int getReg(String a){
        if(a.equals("A")){
            return 1;
        }
        else if(a.equals("B")){
            return 2;
        }
        else if(a.equals("C")){
            return 3;
        }
        else if(a.equals("D")){
            return 4;
        }
        else if(a.equals("E")){
            return 5;
        }
        else if(a.equals("F")){
            return 6;
        }
        else if(a.equals("G")){
            return 7;
        }
        else if(a.equals("H")){
            return 8;
        }
        else if(a.equals("a")){
            return 9;
        }
        else if(a.equals("b")){
            return 10;
        }
        else if(a.equals("c")){
            return 11;
        }
        else if(a.equals("d")){
            return 12;
        }
        else if(a.equals("e")){
            return 13;
        }
        else if(a.equals("f")){
            return 14;
        }
        else if(a.equals("g")){
            return 15;
        }
        else if(a.equals("h")){
            return 16;
        }
        else if(a.equals("i")){
            return 17;
        }
        else if(a.equals("j")){
            return 18;
        }
        else if(a.equals("k")){
            return 19;
        }
        else if(a.equals("l")){
            return 20;
        }
        else if(a.equals("m")){
            return 21;
        }
        else if(a.equals("n")){
            return 22;
        }
        else if(a.equals("o")){
            return 23;
        }
        else if(a.equals("p")){
            return 24;
        }
        return 0;
    }
    public static void assemble(String file,ASMList asml){
String linestr="";
        try{
            FileInputStream fis=new FileInputStream(file);
            BufferedReader dis=new BufferedReader(new InputStreamReader(fis));
//            DataInputStream dis=new DataInputStream(fis);
            String line=null;
            while((line=dis.readLine())!=null){
linestr=line;
                int llen=line.length();
                if(llen>=2&&line.substring(0,2).equals("//")){
                }
                else{
                    if(line.substring(llen-1,llen).equals(":")){
                        asml.nextlabel=line.substring(0,llen-1);
                        asml.add(asml.nextlabel);
                    }
                    else{
                        ASM asm=null;
                        int opcode=0;
                        int rega=0;
                        int regb=0;
                        int regc=0;
                        if(llen>=7&&line.substring(0,4).equals("ADD ")){
                            rega=getReg(line.substring(4,5));
                            regb=getReg(line.substring(6,7));
                            regc=rega;
                            if(llen>=9&&line.substring(7,8).equals(",")){
                                regc=getReg(line.substring(8,9));
                            }
                            opcode=2;
                            if(rega<=8){
                                opcode=3;
                            }
                            asm=new ASM(opcode,rega,regb,regc);
                            asml.add(asm);
                        }
                        else if(llen>=7&&line.substring(0,4).equals("SUB ")){
                            rega=getReg(line.substring(4,5));
                            regb=getReg(line.substring(6,7));
                            regc=rega;
                            if(llen>=9&&line.substring(7,8).equals(",")){
                                regc=getReg(line.substring(8,9));
                            }
                            opcode=5;
                            if(rega<=8){
                                opcode=6;
                            }
                            asm=new ASM(opcode,rega,regb,regc);
                            asml.add(asm);
                        }
                        else if(llen>=8&&line.substring(0,5).equals("MULT ")){
                            rega=getReg(line.substring(5,6));
                            regb=getReg(line.substring(7,8));
                            regc=rega;
                            if(llen>=10&&line.substring(8,9).equals(",")){
                                regc=getReg(line.substring(9,10));
                            }
                            opcode=8;
                            if(rega<=8){
                                opcode=9;
                            }
                            asm=new ASM(opcode,rega,regb,regc);
                            asml.add(asm);
                        }
                        else if(llen>=7&&line.substring(0,4).equals("DIV ")){
                            rega=getReg(line.substring(4,5));
                            regb=getReg(line.substring(6,7));
                            regc=rega;
                            if(llen>=9&&line.substring(7,8).equals(",")){
                                regc=getReg(line.substring(8,9));
                            }
                            opcode=11;
                            if(rega<=8){
                                opcode=12;
                            }
                            asm=new ASM(opcode,rega,regb,regc);
                            asml.add(asm);
                        }
                        else if(llen>=7&&line.substring(0,4).equals("CMP ")){
                            rega=getReg(line.substring(4,5));
                            regb=getReg(line.substring(6,7));
                            regc=rega;
                            if(llen>=9&&line.substring(7,8).equals(",")){
                                regc=getReg(line.substring(8,9));
                            }
                            opcode=14;
                            if(rega<=8){
                                opcode=15;
                            }
                            asm=new ASM(opcode,rega,regb,regc);
                            asml.add(asm);
                        }
                        else if(llen>=5&&line.substring(0,4).equals("JMP ")){
                            rega=getReg(line.substring(4,5));
                            regb=0;
                            regc=0;
                            opcode=19;
                            asm=new ASM(opcode,rega,regb,regc);
                            asml.add(asm);
                        }
                        else if(llen>=7&&line.substring(0,4).equals("JEQ ")){
                            regb=getReg(line.substring(4,5));
                            rega=getReg(line.substring(6,7));
                            regc=0;
                            opcode=20;
                            asm=new ASM(opcode,rega,regb,regc);
                            asml.add(asm);
                        }
                        else if(llen>=9&&line.substring(0,8).equals("LOADKEY ")){
                            regc=getReg(line.substring(8,9));
                            regb=0;
                            rega=0;
                            opcode=23;
                            asm=new ASM(opcode,rega,regb,regc);
                            asml.add(asm);
                        }
                        else if(llen>=9&&line.substring(0,6).equals("QLOAD ")){
                            rega=getReg(line.substring(8,9));
                            regb=getReg(line.substring(6,7));
                            regc=0;
                            opcode=24;
                            asm=new ASM(opcode,rega,regb,regc);
                            asml.add(asm);
                        }
                        else if(llen>=9&&line.substring(0,6).equals("VLOAD ")){
                            regb=getReg(line.substring(8,9));
                            regc=getReg(line.substring(6,7));
                            rega=0;
                            opcode=44;
                            asm=new ASM(opcode,rega,regb,regc);
                            asml.add(asm);
                        }
                        else if(llen>=13&&line.substring(0,13).equals("RESETKEYBOARD")){
                            rega=0;
                            regb=0;
                            regc=0;
                            opcode=30;
                            asm=new ASM(opcode,rega,regb,regc);
                            asml.add(asm);
                        }
                        else if(llen>=4&&line.substring(0,4).equals("NOOP")){
                            rega=0;
                            regb=0;
                            regc=0;
                            opcode=31;
                            asm=new ASM(opcode,rega,regb,regc);
                            asml.add(asm);
                        }
                        else if(llen>=11&&line.substring(0,10).equals("SETBUFFER ")){
                            rega=getReg(line.substring(10,11));
                            regb=0;
                            regc=0;
                            opcode=45;
                            asm=new ASM(opcode,rega,regb,regc);
                            asml.add(asm);
                        }
                        else if(llen>=15&&line.substring(0,14).equals("NUMBEROFCORES ")){
                            regc=getReg(line.substring(14,15));
                            regb=0;
                            rega=0;
                            opcode=46;
                            asm=new ASM(opcode,rega,regb,regc);
                            asml.add(asm);
                        }
                        else if(llen>=12&&line.substring(0,11).equals("CORENUMBER ")){
                            regc=getReg(line.substring(11,12));
                            regb=0;
                            rega=0;
                            opcode=47;
                            asm=new ASM(opcode,rega,regb,regc);
                            asml.add(asm);
                        }
                        else if(llen>=15&&line.substring(0,11).equals("TESTANDSET ")){
                            int ind=0;
                            if(llen>=15&&(ind=line.indexOf("%"))!=-1){
                                if(ind==13){
                                    opcode=48;
                                    regc=getReg(line.substring(11,12));
                                    regb=getReg(line.substring(14,15));
                                    rega=0;
                                }
                                asm=new ASM(opcode,rega,regb,regc);
                                asml.add(asm);
                            }
                        }
                        else if(llen>=4&&line.substring(0,4).equals("DEBU")){
                            rega=0;
                            regb=0;
                            regc=0;
                            opcode=46;
                            asm=new ASM(opcode,rega,regb,regc);
                            asml.add(asm);
                        }
                        else if(llen>=8&&line.substring(0,8).equals("SELFNEXT")){
                            rega=((asml.length+1)/(256*256))%256;
                            regb=((asml.length+1)/256)%256;
                            regc=(asml.length+1)%256;
                            opcode=((asml.length+1)/(256*256*256))%256;
                            asm=new ASM(opcode,rega,regb,regc);
                            asml.add(asm);
                        }
                        else if(llen>=6&&line.substring(0,5).equals("WORD ")){
                            try{
                                int wvalue=new Integer(line.substring(5)).intValue();
                                opcode=wvalue/(256*256*256);
                                rega=(wvalue/(256*256))%256;
                                regb=(wvalue/256%256);
                                regc=wvalue%256;
                                asm=new ASM(opcode,rega,regb,regc);
                                asml.add(asm);
                            }
                            catch(Exception exc){
                            }
                        }
                        else if(llen>=6&&line.substring(0,5).equals("DATA ")){
                            try{
                                int wvalue=new Integer(line.substring(5)).intValue();
                                opcode=0;
                                rega=0;
                                regb=0;
                                regc=0;
                                for(int i=0;i<wvalue;i++){
                                    asm=new ASM(opcode,rega,regb,regc);
                                    asml.add(asm);
                                }
                            }
                            catch(Exception exc2){
                            }
                        }
                        else if(llen>=7&&line.substring(0,5).equals("LOAD ")){
                            int ind=0;
                            if(llen>=9&&(ind=line.indexOf("%"))!=-1){
                                if(ind==5){
                                    opcode=22;
                                    regb=getReg(line.substring(6,7));
                                    rega=getReg(line.substring(8,9));
                                    regc=0;
                                }
                                else{
                                    opcode=21;
                                    regc=getReg(line.substring(5,6));
                                    regb=getReg(line.substring(8,9));
                                    rega=0;
                                }
                                asm=new ASM(opcode,rega,regb,regc);
                                asml.add(asm);
                            }
                            else{
                                if(llen>=8){
                                    regc=getReg(line.substring(5,6));
                                    String rest=line.substring(7);
                                    boolean nonumber=true;
                                    long value=0;
                                    try{
                                        value=new Long(rest).longValue();
                                        nonumber=false;
                                    }
                                    catch(Exception r){
                                    }
                                    opcode=17;
                                    if(regc<=8){
                                        opcode=18;
                                    }
                                    if(nonumber){
                                        rega=getReg(rest);
                                        if(rega==0){
                                            asm=new ASM(rest,opcode,0,0,regc);
                                            asml.add(asm);
                                            ASM asm2=new ASM(31,0,0,0);
                                            asml.add(asm2);
                                        }
                                        else{
                                            opcode=2;
                                            if(regc<=8){
                                                opcode=3;
                                            }
                                            int opcode2=17;
                                            if(regc<=8){
                                                opcode2=18;
                                            }
                                            asm=new ASM(opcode2,0,0,regc);
                                            asml.add(asm);
                                            asm=new ASM(opcode,regc,rega,regc);
                                            asml.add(asm);
                                        }
                                    }
                                    else{
                                        if(value>=256*256){
                                            asm=new ASM(17,(int)((value/(256*256*256))%256),(int)((value/(256*256))%256),9+(regc-1)*2+1);
                                            asml.add(asm);
                                            ASM asm3=new ASM(17,(int)((value/256)%256),(int)(value%256),9+(regc-1)*2);
                                            asml.add(asm3);
                                        }
                                        else{
                                            asm=new ASM(opcode,(int)((value/256)%256),(int)(value%256),regc);
                                            asml.add(asm);
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            fis.close();
        }
        catch(Exception e){
            System.out.println("assemble error: "+e+" ls: "+linestr);
        }
    }
}
class ASMList{
    ASM start;
    ASM end;
    int length=0;
    String nextlabel=null;
    StringListElem startl;
    StringListElem endl;
    LableTable lt=new LableTable();
    public ASMList(){
    }
    public void add(String s){
        StringListElem elem=new StringListElem();
        elem.label=s;
        if(startl==null){
            startl=elem;
            endl=elem;
        }
        else{
            endl.next=elem;
            endl=endl.next;
        }
    }
    public void add(ASM asm){
        if(nextlabel!=null){
            asm.label=nextlabel;
            nextlabel=null;
            StringListElem cur=startl;
            while(cur!=null){
                lt.add(cur.label,length);
                cur=cur.next;
            }
            startl=null;
            endl=null;
        }
        asm.pos=length;
        if(start==null){
            start=asm;
            end=asm;
        }
        else{
            end.next=asm;
            end=end.next;
        }
        length++;
    }
}
class LableTable{
    LableTableElem start;
    LableTableElem end;
    public LableTable(){
    }
    public int getPos(String a){
        LableTableElem cur=start;
        while(cur!=null){
            if(a.equals(cur.lable)){
                return cur.pos;
            }
            cur=cur.next;
        }
        return -1;
    }
    public void add(String a,int b){
//if(a.equals("FILEDATA"))System.out.println("FILEDATA: "+b);
//if(a.equals("MALLOCEND"))System.out.println("MALLOCEND: "+b);
        LableTableElem lte=new LableTableElem(a,b);
        if(start==null){
            start=lte;
            end=lte;
        }
        else{
            end.next=lte;
            end=end.next;
        }
    }
}
class LableTableElem{
    LableTableElem next;
    String lable;
    int pos;
    public LableTableElem(String lable,int pos){
        this.lable=lable;
        this.pos=pos;
    }
}
class ASM{
    ASM next;
    String label;
    String constant;
    int opcode;
    int rega;
    int regb;
    int regc;
    int pos;
    StringListElem start;
    StringListElem end;
    public ASM(String constant,int opcode,int rega,int regb,int regc){
        this.constant=constant;
        this.opcode=opcode;
        this.rega=rega;
        this.regb=regb;
        this.regc=regc;
    }
    public ASM(int opcode,int rega,int regb,int regc){
        this.opcode=opcode;
        this.rega=rega;
        this.regb=regb;
        this.regc=regc;
    }
}
class StringListElem{
    StringListElem next;
    String label;
}
