import java.io.*;
import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import javax.swing.*;
public class XPROInterpreter{
    public static void main(String[]args){
//System.out.println(Runner.getIntOf(0));
        String file="";
        int smallmem=0;
        int bigmem=0;
        int tablelen=0;
        int ncore=1;
        try{
            file=args[0];
            smallmem=Integer.parseInt(args[1]);
            bigmem=Integer.parseInt(args[2]);
            tablelen=Integer.parseInt(args[3]);
            ncore=Integer.parseInt(args[4]);
        }
        catch(Exception e1){
            System.out.println("5 arguments (file smem bmem tmem ncore), parameter error: "+e1);
        }
        long[]smem=new long[smallmem];
        long[]bmem=new long[bigmem];
        try{
            FileInputStream fis=new FileInputStream(file);
            BufferedReader dis=new BufferedReader(new InputStreamReader(fis));
            int inp=0;
            int k=0;
            while((inp=fis.read())!=-1){
                long l=inp;
                for(int j=0;j<3;j++){
                    l=l*256+fis.read();
                }
                smem[k]=l;
                k++;
            }
            if(false){
            int blen=Integer.parseInt(dis.readLine());
            for(int i=0;i<blen/4;i++){
                long l=0;
                for(int j=0;j<4;j++){
                    l=l*256+fis.read();
                }
                bmem[i]=l;
            }
            }
            new Runner(smem,bmem,tablelen,ncore);
        }
        catch(Exception e){
            System.out.println("file load error: "+e);
        }
    }
}
class Runner implements Runnable{
    long[]smem;
    long[]bmem;
    int tablelen;
    int[][]registers;
    int keycode=0;
    float addres;
    float subres;
    float mulres;
    float divres;
    int fires;
    float ifres;
    int cachestart;
    int cacheend;
    int cbigstart;
    int bigstart;
    int bigend;
    int bcachestart;
    DisplayFrameXPRO32Interpreter df=null;
    long[]colors=new long[16];
    long[]screenbuffer=new long[38500];
    long[]screenbuffer2=new long[38500];
    int bufferindex=0;
    int ncore=0;
    Thread t;
    public Runner(long[]smem,long[]bmem,int tablelen,int ncore){
        this.ncore=ncore;
        registers=new int[8][ncore];
        colors[0]=0;
        colors[1]=127;
        colors[2]=32512;
        colors[3]=32639;
        colors[4]=8323072;
        colors[5]=8323199;
        colors[6]=8355584;
        colors[7]=8355711;
        colors[8]=12566463;
        colors[9]=255;
        colors[10]=65280;
        colors[11]=65535;
        colors[12]=16711680;
        colors[13]=16711935;
        colors[14]=16776960;
        colors[15]=16777215;
        this.smem=smem;
        this.bmem=bmem;
        this.tablelen=tablelen;
        df=new DisplayFrameXPRO32Interpreter(this);
        t=new Thread(this);
        t.start();
    }
    public int power2(int n){
        int ret=1;
        for(int i=0;i<n;i++){
            ret=ret*2;
        }
        return ret;
    }
    public static int power2s(int n){
        int ret=1;
        for(int i=0;i<n;i++){
            ret=ret*2;
        }
        return ret;
    }
    public float power2f(int n){
        if(n==0)return 1.0f;
        int m=n;
        if(n<0){
            n=-m;
        }
        int ret=1;
        for(int i=0;i<n;i++){
            ret=ret*2;
        }
        if(m<0){
            return 1.0f/ret;
        }
        return (float)ret;
    }
    public static float power2sf(int n){
        if(n==0)return 1.0f;
        int m=n;
        if(n<0){
            n=-m;
        }
        int ret=1;
        for(int i=0;i<n;i++){
            ret=ret*2;
        }
        if(m<0){
            return 1.0f/ret;
        }
        return (float)ret;
    }
    public float getFloat(int fv){
        int sign=1;
        if(fv/(128*256)==1){
            sign=-1;
        }
        int expo=(fv%(128*256))/(256*4);
        int mant=fv%(256*4)+1024;
        float mantf=0;
        float mantmul=1.0f/(256*8);
        for(int i=0;i<11;i++){
            int cur=mant%2;
            mantf=mantf+mantmul*cur;
            mant=mant/2;
            mantmul=mantmul*2;
        }
        return sign*mantf*power2f(expo-16);
    }
    public static float getFloatOf(int fv){
        int sign=1;
        if(fv/(128*256)==1){
            sign=-1;
        }
        int expo=(fv%(128*256))/(256*4);
        int mant=fv%(256*4)+1024;
//System.out.println("expo: "+expo+" mant: "+mant);
        float mantf=0;
        float mantmul=1.0f/(256*8);
        for(int i=0;i<11;i++){
            int cur=mant%2;
            mantf=mantf+mantmul*cur;
            mant=mant/2;
            mantmul=mantmul*2;
        }
        return sign*mantf*Runner.power2sf(expo-16);
    }
    public int getInt(float fv){
        if(fv==0){
            return 0;
        }
        boolean sign=false;
        if(fv<0){
            fv=-fv;
            sign=true;
        }
        int highexp=16;
        while(fv/power2f(highexp)<0.5f){
            highexp=highexp-1;
            if(highexp<-16){
                return 0;
            }
        }
        int mantmul=256*2*2;
        int mant=0;
        float fvb=fv/power2f(highexp);
        while(fvb>0){
            if(fvb>=0.5f){
                mant=mant+mantmul;
                fvb=(fvb-0.5f)*2;
            }
            else{
                fvb=fvb*2;
            }
            mantmul=mantmul/2;
        }
        int ret=(highexp+16)*256*4+mant-1024;
        if(sign){
            ret=ret+32768;
        }
        return ret;
    }
    public static int getIntOf(float fv){
        if(fv==0){
            return 0;
        }
        boolean sign=false;
        if(fv<0){
            fv=-fv;
            sign=true;
        }
        int highexp=16;
        while(fv/power2sf(highexp)<0.5f){
            highexp=highexp-1;
            if(highexp<-16){
                return 0;
            }
        }
        int mantmul=256*2*2;
        int mant=0;
        float fvb=fv/power2sf(highexp);
        while(fvb>0){
            if(fvb>=0.5f){
                mant=mant+mantmul;
                fvb=(fvb-0.5f)*2;
            }
            else{
                fvb=fvb*2;
            }
            mantmul=mantmul/2;
        }
        int ret=(highexp+16)*256*4+mant-1024;
        if(sign){
            ret=ret+32768;
        }
//System.out.println("highexp: "+highexp+" mant: "+mant+" gf: "+getFloatOf(ret));
        return ret;
    }
    public int getReg8(int rega,int k){
        int regnr=(rega-25);
        int regindex=regnr/4;
        int regpos=regnr%4;
        int regvi=registers[regindex][k];
        long regvl=regvi;
        if(regvi<0){
            regvl=regvl+4294967296l;
        }
        if(regpos==0){
            return (int)regvl%256;
        }
        else if(regpos==1){
            return (int)(regvl/256)%256;
        }
        else if(regpos==2){
            return (int)(regvl/(256*256))%256;
        }
        else if(regpos==3){
            return (int)(regvl/(16777216l))%256;
        }
        return 0;
    }
    public int setReg8(int rega,int value,int k){
        int regnr=(rega-25);
        int regindex=regnr/4;
        int regpos=regnr%4;
        int regvi=registers[regindex][k];
        long regvl=regvi;
        if(regvi<0){
            regvl=regvl+4294967296l;
        }
        if(regpos==0){
            regvl=regvl-regvl%256+value;
        }
        else if(regpos==1){
            regvl=regvl-((regvl/256)%256)*256+value*256;
        }
        else if(regpos==2){
            regvl=regvl-((regvl/(256*256))%256)*256*256+value*256*256;
        }
        else if(regpos==3){
            regvl=regvl-((regvl/(16777216l))%256)*16777216l+value*16777216l;
        }
        return (int)regvl;       
    }
    public int getReg16(int rega,int k){
        int regnr=(rega-9);
        int regindex=regnr/2;
        int regpos=regnr%2;
        int regvi=registers[regindex][k];
        long regvl=regvi;
        if(regvi<0){
            regvl=regvl+4294967296l;
        }
if(regindex==3||regindex==4){
//    System.out.println("regvl0: "+(regvl%(256*256))+" regvl1: "+(regvl/(256*256)));
}
        if(regpos==0){
            return (int)(regvl%(256*256));
        }
        else if(regpos==1){
            return (int)(regvl/(256*256));
        }
        return 0;
    }
    public int setReg16(int rega,int value,int k){
        int regnr=(rega-9);
        int regindex=regnr/2;
        int regpos=regnr%2;
        int regvi=registers[regindex][k];
        long regvl=regvi;
        if(regvi<0){
            regvl=regvl+4294967296l;
        }
if(regindex==3||regindex==4){
//    System.out.println("s regvl0: "+(regvl%(256*256))+" regvl1: "+(regvl/(256*256)));
}
        if(regpos==0){
            regvl=regvl-regvl%(256*256)+value;
        }
        else if(regpos==1){
            regvl=regvl-((regvl/(256*256))%(256*256))*256*256+value*256*256;
        }
        registers[regindex][k]=(int)regvl;
        return (int)regvl;
    }
    public void run(){
        long instr=0;
        int opcode=0;
        try{
        CacheTable ct=new CacheTable(tablelen);
        int[]pc=new int[ncore];
        int[]permutation=new int[ncore];
        long[]addressused=new long[ncore];
        int[]setbufferparams=new int[ncore];
        boolean running=true;
        while(running){
            for(int kc=0;kc<ncore;kc++){
                permutation[kc]=kc;
                addressused[kc]=-1;
                setbufferparams[kc]=-1;
            }
            for(int kc=0;kc<ncore;kc++){
                instr=smem[pc[kc]];
                opcode=(int)(instr/(256*256*256))%256;
                if(opcode==21){
                    int curnum=permutation[kc];
                    for(int kd=kc+1;kd<ncore;kd++){
                        permutation[kd-1]=permutation[kd];
                    }
                    permutation[ncore-1]=curnum;
                }
            }
            for(int kc=0;kc<ncore;kc++){
                instr=smem[pc[kc]];
                opcode=(int)(instr/(256*256*256))%256;
                if(opcode==24){
                    int curnum=permutation[kc];
                    for(int kd=kc+1;kd<ncore;kd++){
                        permutation[kd-1]=permutation[kd];
                    }
                    permutation[ncore-1]=curnum;
                }
            }
            for(int kc=0;kc<ncore;kc++){
                instr=smem[pc[kc]];
                opcode=(int)(instr/(256*256*256))%256;
                if(opcode==44){
                    int curnum=permutation[kc];
                    for(int kd=kc+1;kd<ncore;kd++){
                        permutation[kd-1]=permutation[kd];
                    }
                    permutation[ncore-1]=curnum;
                }
            }
            int oldopcode=0;
            long oldinstr=0;
            int oldpc=0;
            int curkeycode=keycode;
            for(int kb=0;kb<ncore;kb++){
            int k=permutation[kb];
            instr=smem[pc[k]];
            opcode=(int)(instr/(256*256*256))%256;
//if(opcode==20){
//    int xregb=(int)(instr/256)%256;
//    System.out.println("k: "+k+" JMPEQ "+xregb+" ");
//    System.out.println(""+registers[xregb-1][k]);
//}
//System.out.println("opcode: "+k+" "+opcode);
if(true){
//System.out.println("pc: "+pc);
}
//if((oldpc!=pc[permutation[1]])&&kb==1){
//if(pc[permutation[1]]>=2520&&pc[permutation[1]]<=2532&&kb==1){
//System.out.println("started "+pc[0]+" "+pc[1]+" val2560: "+smem[2784]);
//System.out.println("OPCODE: "+opcode+" "+((instr/(256*256))%256)+" "+((instr/256)%256)+" "+(instr%256));
//System.out.println("REGISTERS 0: "+registers[0][0]+" "+registers[1][0]+" "+registers[2][0]+" "+registers[3][0]+" "+registers[4][0]+" "+registers[5][0]+" "+registers[6][0]+" "+registers[7][0]);
//System.out.println("old OPCODE: "+oldopcode+" "+((instr/(256*256))%256)+" "+((instr/256)%256)+" "+(instr%256));
//System.out.println("REGISTERS 1: "+registers[0][1]+" "+registers[1][1]+" "+registers[2][1]+" "+registers[3][1]+" "+registers[4][1]+" "+registers[5][1]+" "+registers[6][1]+" "+registers[7][1]);
//    if(pc[permutation[1]]!=oldpc&&kb==1){
//        System.exit(0);
//    }
//}
//oldopcode=opcode;
//oldinstr=instr;
//oldpc=pc[k];
            if(opcode==1){
                {
                    int rega=(int)(instr/(256*256))%256;
                    int regb=(int)(instr/256)%256;
                    int dest=(int)instr%256;
                    int a=getReg8(rega,k);
                    int b=getReg8(regb,k);
                    if(a>127){
                        a=a-256;
                    }
                    if(b>127){
                        b=b-256;
                    }
                    int c=a+b;
                    if(c>=128){
                        c=c-256;
                    }
                    else if(c<-128){
                        c=c+256;
                    }
                    if(c<0){
                        c=c+128;
                    }
                    setReg8(dest,c,k);
                    pc[k]++;
                }
            }
            else if(opcode==2){
                {
                    int rega=(int)(instr/(256*256))%256;
                    int regb=(int)(instr/256)%256;
                    int dest=(int)instr%256;
                    int a=getReg16(rega,k);
                    int b=getReg16(regb,k);
                    if(a>128*256){
                        a=a-256*256;
                    }
                    if(b>128*256){
                        b=b-256*256;
                    }
                    int c=a+b;
                    if(c>=128*256){
                        c=c-256*256;
                    }
                    else if(c<-128*256){
                        c=c+256*256;
                    }
                    if(c<0){
                        c=c+256*256;
                    }
                    setReg16(dest,c,k);
                    pc[k]++;
                }
            }
            else if(opcode==3){
                {
                    int rega=(int)(instr/(256*256))%256-1;
                    int regb=(int)(instr/256)%256-1;
                    int dest=(int)instr%256-1;
                    registers[dest][k]=registers[rega][k]+registers[regb][k];
                    pc[k]++;
                }
            }
            else if(opcode==4){
                {
                    int rega=(int)(instr/(256*256))%256;
                    int regb=(int)(instr/256)%256;
                    int dest=(int)instr%256;
                    int a=getReg8(rega,k);
                    int b=getReg8(regb,k);
                    if(a>127){
                        a=a-256;
                    }
                    if(b>127){
                        b=b-256;
                    }
                    int c=a-b;
                    if(c>=128){
                        c=c-256;
                    }
                    else if(c<-128){
                        c=c+256;
                    }
                    if(c<0){
                        c=c+128;
                    }
                    setReg8(dest,c,k);
                    pc[k]++;
                }
            }
            else if(opcode==5){
                {
                    int rega=(int)(instr/(256*256))%256;
                    int regb=(int)(instr/256)%256;
                    int dest=(int)instr%256;
                    int a=getReg16(rega,k);
                    int b=getReg16(regb,k);
                    if(a>128*256){
                        a=a-256*256;
                    }
                    if(b>128*256){
                        b=b-256*256;
                    }
                    int c=a-b;
                    if(c>=128*256){
                        c=c-256*256;
                    }
                    else if(c<-128*256){
                        c=c+256*256;
                    }
                    if(c<0){
                        c=c+256*256;
                    }
                    setReg16(dest,c,k);
                    pc[k]++;
                }
            }
            else if(opcode==6){
                {
                    int rega=(int)(instr/(256*256))%256-1;
                    int regb=(int)(instr/256)%256-1;
                    int dest=(int)instr%256-1;
                    registers[dest][k]=registers[rega][k]-registers[regb][k];
//System.out.println("subout: "+registers[(int)dest]+" "+pc);
                    pc[k]++;
                }
            }
            else if(opcode==7){
                {
                    int rega=(int)(instr/(256*256))%256;
                    int regb=(int)(instr/256)%256;
                    int dest=(int)instr%256;
                    int a=getReg8(rega,k);
                    int b=getReg8(regb,k);
                    if(a>127){
                        a=a-256;
                    }
                    if(b>127){
                        b=b-256;
                    }
                    int c=a*b;
                    if(c>=128){
                        c=c-256;
                    }
                    else if(c<-128){
                        c=c+256;
                    }
                    if(c<0){
                        c=c+128;
                    }
                    setReg8(dest,c,k);
                    pc[k]++;
                }
            }
            else if(opcode==8){
                {
                    int rega=(int)(instr/(256*256))%256;
                    int regb=(int)(instr/256)%256;
                    int dest=(int)instr%256;
                    int a=getReg16(rega,k);
                    int b=getReg16(regb,k);
                    if(a>128*256){
                        a=a-256*256;
                    }
                    if(b>128*256){
                        b=b-256*256;
                    }
                    int c=a*b;
                    if(c>=128*256){
                        c=c-256*256;
                    }
                    else if(c<-128*256){
                        c=c+256*256;
                    }
                    if(c<0){
                        c=c+256*256;
                    }
                    setReg16(dest,c,k);
                    pc[k]++;
                }
            }
            else if(opcode==9){
                {
                    int rega=(int)(instr/(256*256))%256-1;
                    int regb=(int)(instr/256)%256-1;
                    int dest=(int)instr%256-1;
                    registers[dest][k]=registers[rega][k]*registers[regb][k];
                    pc[k]++;
                }
            }
            else if(opcode==10){
                {
                    int rega=(int)(instr/(256*256))%256;
                    int regb=(int)(instr/256)%256;
                    int dest=(int)instr%256;
                    int a=getReg8(rega,k);
                    int b=getReg8(regb,k);
                    if(a>127){
                        a=a-256;
                    }
                    if(b>127){
                        b=b-256;
                    }
                    int c=a/b;
                    if(c>=128){
                        c=c-256;
                    }
                    else if(c<-128){
                        c=c+256;
                    }
                    if(c<0){
                        c=c+128;
                    }
                    setReg8(dest,c,k);
                    pc[k]++;
                }
            }
            else if(opcode==11){
                {
                    int rega=(int)(instr/(256*256))%256;
                    int regb=(int)(instr/256)%256;
                    int dest=(int)instr%256;
                    int a=getReg16(rega,k);
                    int b=getReg16(regb,k);
                    if(a>128*256){
                        a=a-256*256;
                    }
                    if(b>128*256){
                        b=b-256*256;
                    }
                    int c=a/b;
                    if(c>=128*256){
                        c=c-256*256;
                    }
                    else if(c<-128*256){
                        c=c+256*256;
                    }
                    if(c<0){
                        c=c+256*256;
                    }
                    setReg16(dest,c,k);
                    pc[k]++;
                }
            }
            else if(opcode==12){
                {
                    int rega=(int)(instr/(256*256))%256-1;
                    int regb=(int)(instr/256)%256-1;
                    int dest=(int)instr%256-1;
                    registers[dest][k]=registers[rega][k]/registers[regb][k];
//System.out.println("divout: "+registers[(int)dest]);
                    pc[k]++;
                }
            }
            else if(opcode==13){
                {
                    int rega=(int)(instr/(256*256))%256;
                    int regb=(int)(instr/256)%256;
                    int dest=(int)instr%256;
                    int a=getReg8(rega,k);
                    int b=getReg8(regb,k);
                    if(a>127){
                        a=a-256;
                    }
                    if(b>127){
                        b=b-256;
                    }
                    int c=0;
                    if(a<b){
                        c=2;
                    }
                    else if(a>b){
                        c=3;
                    }
                    setReg8(dest,c,k);
                    pc[k]++;
                }
            }
            else if(opcode==14){
                {
                    int rega=(int)(instr/(256*256))%256;
                    int regb=(int)(instr/256)%256;
                    int dest=(int)instr%256;
                    int a=getReg16(rega,k);
                    int b=getReg16(regb,k);
                    if(a>128*256){
                        a=a-256*256;
                    }
                    if(b>128*256){
                        b=b-256*256;
                    }
                    int c=0;
                    if(a<b){
                        c=2;
                    }
                    else if(a>b){
                        c=3;
                    }
                    setReg16(dest,c,k);
                    pc[k]++;
                }
            }
            else if(opcode==15){
                {
                    int rega=(int)(instr/(256*256))%256-1;
                    int regb=(int)(instr/256)%256-1;
                    int dest=(int)instr%256-1;
                    int a=registers[rega][k];
                    int b=registers[regb][k];
                    int c=0;
                    if(a<b){
                        c=2;
                    }
                    else if(a>b){
                        c=3;
                    }
                    registers[dest][k]=c;
                    pc[k]++;
                }
            }
            else if(opcode==16){
                {
                    int value=(int)(instr/256)%256;
                    int dest=(int)instr%256;
                    setReg8(dest,value,k);
                    pc[k]++;
                }
            }
            else if(opcode==17){
                {
                    int value=(int)(instr/(256))%(256*256);
                    int dest=(int)instr%256;
                    setReg16(dest,value,k);
                    pc[k]++;
                }
            }
            else if(opcode==18){
                {
                    int value=(int)(instr/(256))%(256*256);
                    int dest=(int)instr%256-1;
                    registers[dest][k]=value;
                    pc[k]++;
                }
            }
            else if(opcode==19){
                {
                    pc[k]=registers[(int)instr/(256*256)%256-1][k];
                }
            }
            else if(opcode==20){
                {
                    if(registers[(int)(instr/256)%256-1][k]==0){
                        pc[k]=registers[(int)instr/(256*256)%256-1][k];
                    }
                    else{
                        pc[k]++;
                    }
                }
            }
            else if(opcode==21){
                {
                    if(registers[(int)(instr/256)%256-1][k]==256*256*256*256-5){
                        registers[(int)instr%256-1][k]=getInt(addres);
                    }
                    else if(registers[(int)(instr/256)%256-1][k]==256*256*256*256-4){
                        registers[(int)instr%256-1][k]=getInt(subres);
                    }
                    else if(registers[(int)(instr/256)%256-1][k]==256*256*256*256-3){
                        registers[(int)instr%256-1][k]=getInt(mulres);
                    }
                    else if(registers[(int)(instr/256)%256-1][k]==256*256*256*256-2){
                        registers[(int)instr%256-1][k]=getInt(divres);
                    }
                    else if(registers[(int)(instr/256)%256-1][k]==256*256*256*256-1){
                        registers[(int)instr%256-1][k]=getInt(ifres)+256*256*fires;
                    }
                    else{
//System.out.println(""+registers[(int)instr%256-1][k]+" k: "+k+" "+registers[(int)(instr/256)%256-1][k]+" pc[k]: "+pc[k]);
                        registers[(int)instr%256-1][k]=(int)smem[registers[(int)(instr/256)%256-1][k]];
                    }
                    pc[k]++;
                }
            }
            else if(opcode==22){
                {
//if(pc>=390&&pc<=400){
//System.out.println("22: "+registers[(int)(instr/256)%256-1]);
//}
                    if(registers[(int)(instr/256)%256-1][k]==(int)(4294967296l-5)){
                        long arguments=registers[(int)(instr/(256*256))%256-1][k];
                        if(arguments<0){
                            arguments=arguments+4294967296l;
                        }
                        int fv1=(int)((arguments/(256*256))%(256*256));
                        int fv2=(int)(arguments%(256*256));
                        float f1=getFloat(fv2);
                        float f2=getFloat(fv1);
                        addres=f1+f2;
//System.out.println("addres: "+addres+" f1: "+f1+" f2: "+f2);
                    }
                    else if(registers[(int)(instr/256)%256-1][k]==(int)(4294967296l-4)){
                        long arguments=registers[(int)(instr/(256*256))%256-1][k];
                        if(arguments<0){
                            arguments=arguments+4294967296l;
                        }
                        int fv1=(int)((arguments/(256*256))%(256*256));
                        int fv2=(int)(arguments%(256*256));
                        float f1=getFloat(fv2);
                        float f2=getFloat(fv1);
                        subres=f1-f2;
//System.out.println("subres: "+subres+" f1: "+f1+" f2: "+f2);
                    }
                    else if(registers[(int)(instr/256)%256-1][k]==(int)(4294967296l-3)){
                        long arguments=registers[(int)(instr/(256*256))%256-1][k];
                        if(arguments<0){
                            arguments=arguments+4294967296l;
                        }
                        int fv1=(int)((arguments/(256*256))%(256*256));
                        int fv2=(int)(arguments%(256*256));
                        float f1=getFloat(fv2);
                        float f2=getFloat(fv1);
                        mulres=f1*f2;
//System.out.println("mulres: "+mulres+" f1: "+f1+" f2: "+f2);
                    }
                    else if(registers[(int)(instr/256)%256-1][k]==(int)(4294967296l-2)){
                        long arguments=registers[(int)(instr/(256*256))%256-1][k];
                        if(arguments<0){
                            arguments=arguments+4294967296l;
                        }
                        int fv1=(int)((arguments/(256*256))%(256*256));
                        int fv2=(int)(arguments%(256*256));
//System.out.println("fv1: "+fv1+" fv2: "+fv2);
                        float f1=getFloat(fv2);
                        float f2=getFloat(fv1);
                        divres=f1/f2;
//System.out.println("divres: "+divres+" f1: "+f1+" f2: "+f2+" getint: "+getIntOf(divres)+" fv1: "+fv1);
                    }
                    else if(registers[(int)(instr/256)%256-1][k]==(int)(4294967296l-1)){
                        long arguments=registers[(int)(instr/(256*256))%256-1][k];
                        if(arguments<0){
                            arguments=arguments+4294967296l;
                        }
                        int fv1=(int)((arguments/(256*256))%(256*256));
                        int fv2=(int)(arguments%(256*256));
                        int neg=fv2/(128*256);
                        if(neg==1){
                            fv2=fv2-256*256;
                        }
                        ifres=(float)fv2;
                        fires=(int)getFloat(fv1);
//System.out.println("fires: "+fires+" fv2: "+fv2+" ifres: "+ifres+" fv1: "+fv1);
                    }
                    else{
                        long longaddressv=registers[(int)(instr/256)%256-1][k];
                        boolean othercorefaster=false;
                        for(int ke=0;ke<kb;ke++){
                            int kf=permutation[ke];
                            if(addressused[kf]==longaddressv){
                                othercorefaster=true;
                            }
                        }
                        if(!othercorefaster){
                            addressused[k]=longaddressv;
                            smem[registers[(int)(instr/256)%256-1][k]]=registers[(int)(instr/(256*256))%256-1][k];
                        }
                    }
                    pc[k]++;
                }
            }
            else if(opcode==23){
                {
                    registers[(int)instr%256-1][k]=curkeycode;
                    pc[k]++;
                }
            }
            else if(opcode==24){
                {
                    boolean novgawrite=false;
                    int wh=registers[(int)(instr/(256))%(256)-1][k];
                    for(int ke=0;ke<kb;ke++){
                        int kf=permutation[ke];
                        if(setbufferparams[kf]==4){
                            if(wh>=65536){
                                novgawrite=true;
                            }
                        }
                        if(setbufferparams[kf]==8){
                            if(wh<65536){
                                novgawrite=true;
                            }
                        }
                    }
                    if(!novgawrite){
                    long colv=registers[(int)(instr/(256*256))%256-1][k];
                    if(colv<0){
                        colv=4294967296l+colv;
                    }
                    int colvi=(int)(colv);
                    if(bufferindex%2==0){
                        screenbuffer[wh]=colv;
                    }
                    else{
                        screenbuffer2[wh]=colv;
                    }
                    int h=(wh*8)/640;
                    int w=(wh*8)%640;
                    int col1=(int)(colv/268435456);
//System.out.println("colv: "+colv+" "+w+" "+h);
                    int col2=(int)((colv/16777216)%16);
                    int col3=(int)((colv/1048576)%16);
                    int col4=(int)((colv/65536)%16);
                    int col5=(int)((colv/4096)%16);
                    int col6=(int)((colv/256)%16);
                    int col7=(int)((colv/16)%16);
                    int col8=(int)(colv%16);
                    if(bufferindex%2==0){
                        df.dc.h.setColor(new Color((int)colors[col1]));
                        df.dc.h.fillRect(w,h,1,1);
                        df.dc.h.setColor(new Color((int)colors[col2]));
                        df.dc.h.fillRect(w+1,h,1,1);
                        df.dc.h.setColor(new Color((int)colors[col3]));
                        df.dc.h.fillRect(w+2,h,1,1);
                        df.dc.h.setColor(new Color((int)colors[col4]));
                        df.dc.h.fillRect(w+3,h,1,1);
                        df.dc.h.setColor(new Color((int)colors[col5]));
                        df.dc.h.fillRect(w+4,h,1,1);
                        df.dc.h.setColor(new Color((int)colors[col6]));
                        df.dc.h.fillRect(w+5,h,1,1);
                        df.dc.h.setColor(new Color((int)colors[col7]));
                        df.dc.h.fillRect(w+6,h,1,1);
                        df.dc.h.setColor(new Color((int)colors[col8]));
                        df.dc.h.fillRect(w+7,h,1,1);
                    }
                    else{
                        df.dc.h2.setColor(new Color((int)colors[col1]));
                        df.dc.h2.fillRect(w,h,1,1);
                        df.dc.h2.setColor(new Color((int)colors[col2]));
                        df.dc.h2.fillRect(w+1,h,1,1);
                        df.dc.h2.setColor(new Color((int)colors[col3]));
                        df.dc.h2.fillRect(w+2,h,1,1);
                        df.dc.h2.setColor(new Color((int)colors[col4]));
                        df.dc.h2.fillRect(w+3,h,1,1);
                        df.dc.h2.setColor(new Color((int)colors[col5]));
                        df.dc.h2.fillRect(w+4,h,1,1);
                        df.dc.h2.setColor(new Color((int)colors[col6]));
                        df.dc.h2.fillRect(w+5,h,1,1);
                        df.dc.h2.setColor(new Color((int)colors[col7]));
                        df.dc.h2.fillRect(w+6,h,1,1);
                        df.dc.h2.setColor(new Color((int)colors[col8]));
                        df.dc.h2.fillRect(w+7,h,1,1);
                    }
                    }
                    pc[k]++;
                }
            }
            else if(opcode==44){
                {
                    if(bufferindex%2==0){
                        registers[(int)instr%256-1][k]=(int)screenbuffer[registers[(int)(instr/256)%256-1][k]];
                    }
                    else{
                        registers[(int)instr%256-1][k]=(int)screenbuffer2[registers[(int)(instr/256)%256-1][k]];
                    }
                    pc[k]++;
                }
            }
            else if(opcode==45){
                int bufferind=registers[(int)(instr/(256*256))%256-1][k];
                boolean othercorefaster=false;
                for(int ke=0;ke<kb;ke++){
                    int kf=permutation[ke];
                    if(setbufferparams[kf]>=0&&setbufferparams[kf]<4){
                        othercorefaster=true;
                    }
                }
                if(bufferind==4){
                    setbufferparams[k]=4;
                    for(int i=0;i<38400;i++){
                        screenbuffer2[i]=screenbuffer[i];
                    }
                    drawb();
                }
                else if(bufferind==8){
                    setbufferparams[k]=8;
                    for(int i=0;i<38400;i++){
                        screenbuffer[i]=screenbuffer2[i];
                    }
                    drawa();
                }
                else{
                    if(!othercorefaster){
                        setbufferparams[k]=bufferind;
                        bufferindex=bufferind/2;
                        if(bufferind%2==1){
                            df.dc.otherimage=true;
                        }
                        else{
                            df.dc.otherimage=false;
                        }
                    }
                }
                pc[k]++;
            }
            else if(opcode>=25&&opcode<=29){
                pc[k]++;
            }
            else if(opcode==30){
                keycode=0;
                pc[k]++;
            }
            else if(opcode==31){
                pc[k]++;
            }
            else if(opcode==46){
                {
                    registers[(int)instr%256-1][k]=ncore;
                    pc[k]++;
                }
            }
            else if(opcode==47){
                {
                    registers[(int)instr%256-1][k]=k;
                    pc[k]++;
                }
            }
            else if(opcode==48){
                {
                    long longaddressv=registers[(int)(instr/256)%256-1][k];
                    boolean othercorefaster=false;
                    for(int ke=0;ke<kb;ke++){
                        int kf=permutation[ke];
                        if(addressused[kf]==longaddressv){
                            othercorefaster=true;
                        }
                    }
                    if(!othercorefaster){
                        addressused[k]=longaddressv;
                        long curvalue=(int)smem[registers[(int)(instr/256)%256-1][k]];
                        if(curvalue==0){
                            smem[registers[(int)(instr/256)%256-1][k]]=1;
                            registers[(int)instr%256-1][k]=1;
                        }
                        else{
                            registers[(int)instr%256-1][k]=0;
                        }
                    }
                    else{
                        registers[(int)instr%256-1][k]=0;
                    }
                    pc[k]++;
                }
            }
            else if(opcode==460){
System.out.println("OPCODE: "+opcode+" "+((instr/(256*256))%256)+" "+((instr/256)%256)+" "+(instr%256));
System.out.println("REGISTERS: "+registers[0]+" "+registers[1]+" "+registers[2]+" "+registers[3]+" "+registers[4]+" "+registers[5]+" "+registers[6]+" "+registers[7]);
while(keycode==0)try{Thread.sleep(100);}catch(Exception e){};
keycode=0;
                pc[k]++;
            }
            else if(opcode==32){
                cachestart=registers[(int)(instr/(256*256))%(256*256)][k];
                pc[k]++;
            }
            else if(opcode==33){
                cacheend=registers[(int)(instr/(256*256))%(256*256)][k];
                pc[k]++;
            }
            else if(opcode==34){
                cbigstart=registers[(int)(instr/(256*256))%(256*256)][k];
                pc[k]++;
            }
            else if(opcode==35){
                int cb=cbigstart;
                for(int i=cachestart;i<=cacheend;i++){
                    bmem[cb]=smem[i];
                    cb++;
                }
                pc[k]++;
            }
            else if(opcode==36){
                bigstart=registers[(int)(instr/(256*256))%(256*256)][k];
                pc[k]++;
            }
            else if(opcode==37){
                bigend=registers[(int)(instr/(256*256))%(256*256)][k];
                pc[k]++;
            }
            else if(opcode==38){
                bcachestart=registers[(int)(instr/(256*256))%(256*256)][k];
                pc[k]++;
            }
            else if(opcode==39){
                int bc=bcachestart;
                for(int i=bigstart;i<=bigend;i++){
                    smem[bc]=bmem[i];
                    bc++;
                }
                pc[k]++;
            }
            else if(opcode==40){
                ct.addKey(registers[(int)(instr/(256*256))%(256*256)-1][k],registers[(int)(instr/256)%256-1][k]);
                pc[k]++;
            }
            else if(opcode==41){
                ct.addVal(registers[(int)(instr/(256*256))%(256*256)-1][k],registers[(int)(instr/256)%256-1][k]);
                pc[k]++;
            }
            else if(opcode==42){
                registers[(int)instr%256-1][k]=ct.getVal(registers[(int)(instr/(256*256))%(256*256)-1][k]);
                pc[k]++;
            }
            else if(opcode==43){
                registers[(int)instr%256-1][k]=ct.getAddr(registers[(int)(instr/(256*256))%(256*256)-1][k]);
                pc[k]++;
            }
            else{
                System.out.println("program exit: "+opcode);
                return;
            }
        }
        }
        }
        catch(Exception e){
System.out.println("CRASH OPCODE: "+opcode+" "+((instr/(256*256))%256)+" "+((instr/256)%256)+" "+(instr%256));
System.out.println("REGISTERS: "+registers[0][0]+" "+registers[1][0]+" "+registers[2][0]+" "+registers[3][0]+" "+registers[4][0]+" "+registers[5][0]+" "+registers[6][0]+" "+registers[7][0]);
            System.out.println("program crash error e: "+e);
            e.printStackTrace();
        }
    }
    public void drawa(){
        for(int i=0;i<38400;i++){
            int wh=i;
            long colv=screenbuffer[wh];
            if(colv<0){
                colv=4294967296l+colv;
            }
            int colvi=(int)(colv);
            int h=(wh*8)/640;
            int w=(wh*8)%640;
            int col1=(int)(colv/268435456);
            int col2=(int)((colv/16777216)%16);
            int col3=(int)((colv/1048576)%16);
            int col4=(int)((colv/65536)%16);
            int col5=(int)((colv/4096)%16);
            int col6=(int)((colv/256)%16);
            int col7=(int)((colv/16)%16);
            int col8=(int)(colv%16);
            df.dc.h.setColor(new Color((int)colors[col1]));
            df.dc.h.fillRect(w,h,1,1);
            df.dc.h.setColor(new Color((int)colors[col2]));
            df.dc.h.fillRect(w+1,h,1,1);
            df.dc.h.setColor(new Color((int)colors[col3]));
            df.dc.h.fillRect(w+2,h,1,1);
            df.dc.h.setColor(new Color((int)colors[col4]));
            df.dc.h.fillRect(w+3,h,1,1);
            df.dc.h.setColor(new Color((int)colors[col5]));
            df.dc.h.fillRect(w+4,h,1,1);
            df.dc.h.setColor(new Color((int)colors[col6]));
            df.dc.h.fillRect(w+5,h,1,1);
            df.dc.h.setColor(new Color((int)colors[col7]));
            df.dc.h.fillRect(w+6,h,1,1);
            df.dc.h.setColor(new Color((int)colors[col8]));
            df.dc.h.fillRect(w+7,h,1,1);
        }
    }
    public void drawb(){
        for(int i=0;i<38400;i++){
            int wh=i;
            long colv=screenbuffer2[wh];
            if(colv<0){
                colv=4294967296l+colv;
            }
            int colvi=(int)(colv);
            int h=(wh*8)/640;
            int w=(wh*8)%640;
            int col1=(int)(colv/268435456);
            int col2=(int)((colv/16777216)%16);
            int col3=(int)((colv/1048576)%16);
            int col4=(int)((colv/65536)%16);
            int col5=(int)((colv/4096)%16);
            int col6=(int)((colv/256)%16);
            int col7=(int)((colv/16)%16);
            int col8=(int)(colv%16);
            df.dc.h2.setColor(new Color((int)colors[col1]));
            df.dc.h2.fillRect(w,h,1,1);
            df.dc.h2.setColor(new Color((int)colors[col2]));
            df.dc.h2.fillRect(w+1,h,1,1);
            df.dc.h2.setColor(new Color((int)colors[col3]));
            df.dc.h2.fillRect(w+2,h,1,1);
            df.dc.h2.setColor(new Color((int)colors[col4]));
            df.dc.h2.fillRect(w+3,h,1,1);
            df.dc.h2.setColor(new Color((int)colors[col5]));
            df.dc.h2.fillRect(w+4,h,1,1);
            df.dc.h2.setColor(new Color((int)colors[col6]));
            df.dc.h2.fillRect(w+5,h,1,1);
            df.dc.h2.setColor(new Color((int)colors[col7]));
            df.dc.h2.fillRect(w+6,h,1,1);
            df.dc.h2.setColor(new Color((int)colors[col8]));
            df.dc.h2.fillRect(w+7,h,1,1);
        }
    }
}
class DisplayFrameXPRO32Interpreter extends JFrame implements KeyListener{
    Runner r;
    DisplayCanvasXPRO32Interpreter dc;
    private static final long serialVersionUID = 8990343939585000054L;
    public DisplayFrameXPRO32Interpreter(Runner r){
        super("VGA Output");
        pack();
        setSize(680,580);
        setLayout(null);
        this.r=r;
        dc=new DisplayCanvasXPRO32Interpreter(r);
        add(dc);
        dc.setBounds(10,40,640,480);
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setVisible(true);
        setFocusable(true);
        addKeyListener(this);
        requestFocus();
    }
    public void keyTyped(KeyEvent e){
    }
    public void keyPressed(KeyEvent e){
        requestFocus();
        process(e);
    }
    public void keyReleased(KeyEvent e){
    }
    public void process(KeyEvent evt){
        int keyb=evt.getKeyCode();
        if(keyb==KeyEvent.VK_SHIFT){
            return;
        }
        if(!evt.isShiftDown()&&keyb>=0&&keyb<256){
            byte[]by=new byte[1];
            by[0]=(byte)keyb;
            String s=new String(by);
            s=s.toLowerCase();
            byte[]byb=s.getBytes();
            keyb=byb[0];
        }
            if(keyb==KeyEvent.VK_DELETE){
//System.out.println("smemv: "+r.smem[62994]);
//return false;
            }
            if(keyb==KeyEvent.VK_DOWN){
                byte[]by1="P".getBytes();
                r.keycode=32*256+by1[0];
            }
            else if(keyb==KeyEvent.VK_UP){
                byte[]by2="H".getBytes();
                r.keycode=32*256+by2[0];
            }
            else if(keyb==KeyEvent.VK_LEFT){
                byte[]by3="K".getBytes();
                r.keycode=32*256+by3[0];
            }
            else if(keyb==KeyEvent.VK_RIGHT){
                byte[]by4="M".getBytes();
                r.keycode=32*256+by4[0];
            }
            else{
                r.keycode=keyb;
            }
//System.out.println(r.keycode);
    }
}
class DisplayCanvasXPRO32Interpreter extends JPanel implements Runnable{
    Graphics h;
    Graphics h2;
    BufferedImage img;
    BufferedImage img2;
    ImageFrameXPRO32Interpreter imf;
    Runner r;
    Thread t;
    boolean otherimage=false;
    private static final long serialVersionUID = -1113477596623270304L;
    public DisplayCanvasXPRO32Interpreter(Runner r){
        this.r=r;
        imf=new ImageFrameXPRO32Interpreter();
        img=imf.img;
        img2=imf.img2;
        h=img.getGraphics();
        h.setColor(Color.black);
        h.fillRect(0,0,640,480);
        h2=img2.getGraphics();
        h2.setColor(Color.black);
        h2.fillRect(0,0,640,480);
        t=new Thread(this);
        t.start();
    }
    public void run(){
        boolean running=true;
        while(running){
            try{
                repaint();
                Thread.sleep(100);
            }
            catch(Exception e){
                System.out.println("frame error: "+e);
            }
        }
    }
    public void paint(Graphics g){
        if(otherimage){
            g.drawImage(img2,0,0,this);
        }
        else{
            g.drawImage(img,0,0,this);
        }
    }
}
class ImageFrameXPRO32Interpreter extends JFrame{
    BufferedImage img;
    BufferedImage img2;
    private static final long serialVersionUID = -4312601567350417822L;
    public ImageFrameXPRO32Interpreter(){
        pack();
        img=new BufferedImage(640,480,BufferedImage.TYPE_INT_ARGB);
        img2=new BufferedImage(640,480,BufferedImage.TYPE_INT_ARGB);
    }
}
class CacheTable{
    int tablelen;
    int[]key;
    int[]val;
    public CacheTable(int tablelen){
        this.tablelen=tablelen;
        key=new int[tablelen];
        val=new int[tablelen];
    }
    public void addKey(int value,int addr){
        key[addr]=value;
    }
    public void addVal(int value,int addr){
        val[addr]=value;
    }
    public int getVal(int keyvalue){
        for(int i=0;i<tablelen;i++){
            if(key[i]==keyvalue){
                return val[i];
            }
        }
        return 0;
    }
    public int getAddr(int keyvalue){
        for(int i=0;i<tablelen;i++){
            if(key[i]==keyvalue){
                return i;
            }
        }
        return 0;
    }
}
